<?php

	define('APS_DEVELOPMENT_MODE', true);
	require "aps/2/runtime.php";	

	/**
	* Class context
	* @type("http://aps-standard.org/samples/bind2domain/context/1.0")
	* @implements("http://aps-standard.org/types/core/subscription/service/1.0")
	*/
	
	class context extends \APS\ResourceBase
	{
	   ## Strong relation (link) to the application instance
	   /**
	   * @link("http://aps-standard.org/samples/bind2domain/cloud/1.0")
	   * @required
	   */
	   public $cloud;
	
	   ## Weak relation (link) to collection of VPSes
	   /**
	    * @link("http://aps-standard.org/samples/bind2domain/vps/1.0[]")
	    */
	   public $vpses;
	   
	   /**
	    * @link("http://aps-standard.org/types/dns/domain/1.0[]")
	    */
	   public $paDomains;
	   
	   /**
	    * @verb(POST)
	    * @path("/onBindToDomain")
	    * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
	    */
	   public function onBindToDomain($domainNotification) {
	   	## For debugging only - log the input notification
	   	\APS\LoggerRegistry::get()->info("Domain bound: ".json_format($domainNotification));
	   
	   	## Connect to the APS controller
	   	$apsc2 = \APS\Request::getController();
	   
	   	##Impersonate the app to get access to a domain provided by the Domain Manager
	   	$apsc = $apsc2->impersonate($this);
	   
	   	## Get APS resource representing the registered domain
	   	$domain = $apsc->getResource($domainNotification->parameters->domain->id);
	   
	   	## Link the *management context* with the domain - add the link to collection paDomains
	   	$apsc->linkResource($this,'paDomains',$domain);
	   }
	   
	   public function provision() {
	   
	   	#### Connect to the APS controller
	   	$apsc = \APS\Request::getController();
	   	if ($apsc == null) {
	   		error_log("apsc is null");
	   	}
	   
	   	#### Create a subscription to the "bind-to-domain" event
	   	$subBindToDomain = new \APS\EventSubscription(
	   	\APS\EventSubscription::BindServicesToDomain,
	   	"onBindToDomain"
	   			);
	   
	   	#### Create an "event source" object based on the standard class
	   	$subBindToDomain->source = new stdClass();
	   
	   	#### Activate the event subscription
	   	## Event source is the current hosting subscription
	   	$subBindToDomain->source->id=$this->subscription->aps->id;
	   	$apsc->subscribe($this, $subBindToDomain);
	   }
	}
?>
